Bug 155706 - net/quagga: ripd is broken
net/quagga: ripd is broken
Status: Closed FIXED
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s)
Latest
Any Any
: Normal Affects Only Me
Assigned To: Sergey Matveychuk
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-03-19 22:00 UTC by eugen
Modified: 2011-04-02 19:20 UTC (History)
0 users

See Also:


Attachments
file.diff (2.90 KB, patch)
2011-03-19 22:00 UTC, eugen
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description eugen 2011-03-19 22:00:10 UTC
	quagga can join interface to multicast group either
	with the RFC 1724 hack or with ip_mreqn/IP_MULTICAST_IF.

	The RFC 1724 hack for interface selection has been removed
	from FreeBSD since 7.0-RELEASE (see entry 20070612 in /usr/src/UPDATIN).
	
	The port net/quagga since quagga-0.99.17_2 contains files/patch-lib-sockopt.c
	that effectively disables use of ip_mreqn. This change broke ripd
	for FreeBSD 7.0 and later.

	ripd with this change still works in 6.x where RFC 1724 hack exists.

Fix: The following patch is taken from
	https://bugzilla.quagga.net/show_bug.cgi?id=420

	We need to remove our own files/patch-lib-sockopt.c
	and replace it with this one. I've tested it with ripd and ospfd,
	it works just fine for ngX and gifX interfaces.
How-To-Repeat: 
	In FreeBSD 8.2, for ngX interfaces created by net/mpd5
	ripd cannot join multicast group and complains to the log:

Can't setsockopt IP_MULTICAST_IF on fd 11 to source address 192.168.100.50 for interface ng2
can't send packet : Permission denied

	These lines repeat every 32 seconds while ripd is running.
Comment 1 Edwin Groothuis freebsd_committer 2011-03-19 22:00:20 UTC
Maintainer of net/quagga,

Please note that PR ports/155706 has just been submitted.

If it contains a patch for an upgrade, an enhancement or a bug fix
you agree on, reply to this email stating that you approve the patch
and a committer will take care of it.

The full text of the PR can be found at:
    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/155706

-- 
Edwin Groothuis via the GNATS Auto Assign Tool
edwin@FreeBSD.org
Comment 2 Edwin Groothuis freebsd_committer 2011-03-19 22:00:22 UTC
State Changed
From-To: open->feedback

Awaiting maintainers feedback (via the GNATS Auto Assign Tool)
Comment 3 Sergey Matveychuk freebsd_committer 2011-04-01 15:46:36 UTC
Responsible Changed
From-To: freebsd-ports-bugs->sem

Take it.
Comment 4 dfilter freebsd_committer 2011-04-02 19:15:18 UTC
sem         2011-04-02 18:15:01 UTC

  FreeBSD ports repository

  Modified files:
    net/quagga           Makefile 
    net/quagga/files     patch-lib-sockopt.c 
  Log:
  - Fix ripd on 7.0+.
    ripd could not join multicast group and complains to the log:
    Can't setsockopt IP_MULTICAST_IF on fd 11 to source address XXX.XXX.XXX.XXX
    for interface ng2 can't send packet : Permission denied
  
  PR:             ports/155706
  Submitted by:   Eugene Grosbein
  Approved by:    maintainer
  
  Revision  Changes    Path
  1.109     +1 -1      ports/net/quagga/Makefile
  1.4       +79 -11    ports/net/quagga/files/patch-lib-sockopt.c
_______________________________________________
cvs-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/cvs-all
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"
Comment 5 Sergey Matveychuk freebsd_committer 2011-04-02 19:15:24 UTC
State Changed
From-To: feedback->closed

Committed. Thanks!